var kekkaArr = new Array();


$(function(){

	//座標処理
	$('p.point input').change(function(){
			calcTime();
	}).keydown(function (e) { 
		if( e.keyCode == 13){
			calcTime();
		}
	});
	
	//速度処理
	$('select').change(function(){
		calcTime();
	})
	
	$('#move2').change(function(){
		calcTime();
	}).keydown(function (e) { 
		if( e.keyCode == 13){
			calcTime();
		}
	});
	
	$('#move3').click(function(){
		calcTime();
	})
	

	$('input.opBBS').click(function(){
		outputBBS();
	})
});

function calcTime(){
	resetAll()
	//座標入力チェック
	var chkFlg = 0;

	$('p.point input').each(function(){
		if($(this).val().search(/^[-]?\d+(\.\d+)?$/) == -1 && $(this).val() != "") {
			alert("座標は半角数字で入力してね");
			$(this).focus();
			$(this).addClass('pink');
			chkFlg = 1
		}
	});
	
	$('#move2').each(function(){
		if($(this).val().search(/^[-]?\d+(\.\d+)?$/) == -1 && $(this).val() != "") {
			alert("補正は半角数字で入力するんだぜ");
			$(this).focus();
			$(this).addClass('pink');
			chkFlg = 1
		}
	});
	
	if (chkFlg == 1){
		$('#submit').hide();
		return false;
	}
	
	$('p.point input').removeClass('pink');
	
	//距離計算
	var motoX = $('#motoX').val();
	var motoY = $('#motoY').val();
	var sakiX = $('#sakiX').val();
	var sakiY = $('#sakiY').val();
	var distance;
	
	if (motoX && motoY && sakiX && sakiY){
		distance = Math.sqrt((motoX-sakiX)*(motoX-sakiX)+(motoY-sakiY)*(motoY-sakiY));
		distance = Math.round(distance * 100) / 100;
		
		$('#dist').html('距離は　<span class="aka futo">'+distance+'　</span>だよ')
		//時間計算
		var moveRate = $('#move1').val();
		var moveSkill = $('#move2').val();
		var moveTime;
		var moveTimeTex;
		
		if (!moveSkill){
			moveSkill = 0;
		}
		
		moveSkill = 100 + parseFloat(moveSkill);
		
		if ($('#move3').attr('checked')==true){
			moveSkill +=20;
		}
		
		moveSkill = moveSkill/100

		//移動時間計算
		moveTime = distance * 3600;
		moveTime = Math.floor(moveTime/(moveRate*moveSkill));
		moveTimeTex = Math.floor(moveTime/3600)+"時間"+Math.floor(moveTime%3600/60)+"分"+Math.floor(moveTime%60)+"秒";
		$('#moveTime').html('移動時間は　<span class="aka futo">'+moveTimeTex+'</span>　さ');
		
		//出発時間計算
		var leaveTime = Date.parse($('#year').val()+"/"+$('#month').val()+"/"+$('#day').val()+" "+$('#hour').val()+":"+$('#min').val()+":"+$('#sec').val());
		
		var monthTex;
		var dayTex;
		var hourTex;
		var minTex;
		var secTex;
		
		if ($('#month').val()<10){
			monthTex = "0"+$('#month').val()
		}else{
			monthTex = $('#month').val();
		}
		if ($('#day').val()<10){
			dayTex = "0"+$('#day').val()
		}else{
			dayTex = $('#day').val();
		}
		if ($('#hour').val()<10){
			hourTex = "0"+$('#hour').val()
		}else{
			hourTex = $('#hour').val();
		}
		if ($('#min').val()<10){
			minTex = "0"+$('#min').val()
		}else{
			minTex = $('#min').val();
		}
		if ($('#sec').val()<10){
			secTex = "0"+$('#sec').val()
		}else{
			secTex = $('#sec').val();
		}
		
		var leaveTimeTex = $('#year').val()+"年"+monthTex+"月"+dayTex+"日　"+hourTex+"時"+minTex+"分"+secTex+"秒";

		
		var startTime = new Date();
		startTime.setTime(leaveTime-moveTime*1000);

		monthTex = startTime.getMonth()+1;
		dayTex = startTime.getDate()
		hourTex = startTime.getHours();
		minTex = startTime.getMinutes();
		secTex = startTime.getSeconds();

		if (monthTex<10){
			monthTex = "0"+monthTex
		}
		if (dayTex<10){
			dayTex = "0"+ dayTex
		}
		if (hourTex<10){
			hourTex = "0"+hourTex;
		}
		if (minTex<10){
			minTex = "0"+minTex;
		}
		if (secTex<10){
			secTex = "0"+secTex;
		}

		
		var startTimeTex = startTime.getFullYear()  + "年" + monthTex + "月" + dayTex + "日　" + hourTex + "時" + minTex + "分" + secTex +"秒";

		
		//民兵予測
		var powerRate = $('#star').val();
		var category = $('#sigen').val();
		
		if (powerRate != "none"){
			var soldier;
			var heika = new Array("剣","槍","弓","騎","矛","弩","近");
			var soldierTex = "";
			soldier = calcSolder(powerRate,category,distance);
			for (var i = 0; i < soldier.length; i++) {
				soldierTex = soldierTex+heika[i]+"："+soldier[i]+"　";
			}
			soldierTex
			$('<br /><span>予測最大民兵数：　'+soldierTex+'</span>').appendTo('#dist');
			
		}
		
		
		//結果表示
		$('#submit').remove();
		$('<span class="kekka aka">　　'+distance+'</span>').appendTo('#kDist');
		$('<span class="kekka aka">　　'+moveRate+'</span>').appendTo('#kSold');
		$('<span class="kekka aka dekka futo">　　'+startTimeTex+'</span>').appendTo('#kGo');
		$('<span class="kekka aka">　　'+moveTimeTex+'</span>').appendTo('#kMove');
		$('<span class="kekka aka">　　'+leaveTimeTex+'</span>').appendTo('#kLeave');
		$('#kLeave').after('<input type="button" id="submit" value="この結果を置き場へ追加するんだ" />');
		
		//結果ため込み
		
		$('#submit').click(function(){
			kekkaArr.push({
				'motoX':motoX,
				'motoY':motoY,
				'sakiX':sakiX,
				'sakiY':sakiY,
				'dist':distance,
				'moveRate':moveRate,
				'moveSkill':moveSkill*100,
				'startTime':startTime,
				'startTimeTex':startTimeTex,
				'moveTime':moveTime,
				'moveTimeTex':moveTimeTex,
				'leaveTime':leaveTime,
				'leaveTimeTex':leaveTimeTex,
				'pName':$('#pName').val(),
				'memo':$('#memo').val()
			});
			submitKekka();
		});

		

	}else{
		resetAll();
		return false;
	}
	

	
}

function calcSolder(powerRate,category,distance){
	var soldier=new Array(7);
	var maxSoldier = 0;
	var minSoldier = 0;
	
	for(i = 0; i < 7; i++) {
		soldier[i] = 0;
	}
	
	if (powerRate == 1){
		soldier[0] = Math.ceil(distance*1.5+15);
	}else if (powerRate == 2){
		minSoldier = Math.ceil(distance*0.15+1.5);
		maxSoldier = Math.ceil(distance*1.2+12);
		for(i = 1; i < 4; i++) {
			soldier[i] = minSoldier;
		}
		if (category == "森"){
			soldier[2] = maxSoldier;
		}else if  (category == "岩"){
			soldier[1] = maxSoldier;
		}else if  (category == "鉄"){
			soldier[3] = maxSoldier;
		}
	}else if (powerRate == 3){
		maxSoldier = Math.ceil(distance*1.8+18);
		soldier[1] = maxSoldier;
		soldier[2] = maxSoldier;
		soldier[3] = maxSoldier;
	}else if (powerRate == 4){
		maxSoldier = Math.ceil(distance*3.75+37.5);
		minSoldier = Math.ceil(maxSoldier*0.6);
		soldier[1] = maxSoldier+"～"+minSoldier;
		soldier[2] = maxSoldier+"～"+minSoldier;
		soldier[3] = maxSoldier+"～"+minSoldier;
	}else if (powerRate == 5){
		minSoldier = Math.ceil(distance*3+30);
		maxSoldier = Math.ceil(distance*12+120);
		for(i = 1; i < 4; i++) {
			soldier[i] = minSoldier;
		}
		if (category == "森"){
			soldier[2] = maxSoldier;
		}else if  (category == "岩"){
			soldier[1] = maxSoldier;
		}else if  (category == "鉄"){
			soldier[3] = maxSoldier;
		}
	}else if (powerRate == 6){
		minSoldier = Math.ceil(distance*4.5+45);
		maxSoldier = Math.ceil(distance*22.5+225);
		for(i = 1; i < 4; i++) {
			soldier[i] = minSoldier;
		}
		if (category == "森"){
			soldier[1] = maxSoldier;
		}else if  (category == "岩"){
			soldier[2] = maxSoldier;
		}else if  (category == "鉄"){
			soldier[3] = maxSoldier;
		}
	}else if (powerRate == 7){
		maxSoldier = Math.ceil(distance*15+150);
		minSoldier = Math.ceil(maxSoldier*0.6);
		for(i = 4; i < 7; i++) {
			soldier[i] =  maxSoldier+"～"+minSoldier;
		}
	}else if (powerRate == 8){
		maxSoldier = Math.ceil(distance*30+300);
		minSoldier = Math.ceil(maxSoldier*0.6);
		for(i = 4; i < 7; i++) {
			soldier[i] =  maxSoldier+"～"+minSoldier;
		}
	}else if (powerRate == 9){
		maxSoldier = Math.ceil(distance*45+450);
		minSoldier = Math.ceil(maxSoldier*0.6);
		for(i = 4; i < 7; i++) {
			soldier[i] =  maxSoldier+"～"+minSoldier;
		}
	}
	return soldier;
}

function submitKekka(){
	$('div#kekkaOkiba').slideDown();
	$('div#kekkaOkiba table').remove();
	$('<table class="tablesorter"><thead><tr><th>出発時刻</th><th>プレイヤー名</th><th>出兵元</th><th>出兵先</th><th>移動距離</th><th>基本速度</th><th>速度補正</th><th>到着時刻</th><th>移動時間</th><th>メモ</th><th>操作</th></tr></thead><tbody></tbody></table>').appendTo('div#kekkaOkiba');
	
	for (var item in kekkaArr){
		$('<tr><td class="futo">'+kekkaArr[item].startTimeTex+'</td>'+'<td>'+kekkaArr[item].pName+'</td>'+'<td>('+kekkaArr[item].motoX+','+kekkaArr[item].motoY+')</td>'+'<td>('+kekkaArr[item].sakiX+','+kekkaArr[item].sakiY+')</td>'+'<td>'+kekkaArr[item].dist+'</td>'+'<td>'+kekkaArr[item].moveRate+'</td>'+'<td>'+kekkaArr[item].moveSkill+'%</td>'+'<td>'+kekkaArr[item].leaveTimeTex+'</td>'+'<td>'+kekkaArr[item].moveTimeTex+'</td>'+'<td>'+kekkaArr[item].memo+'</td><td><input type="button" class="delTr" value="行消去"></td></tr>').appendTo('div#kekkaOkiba table tbody')
	}
	
	$('.delTr').each(function(index){
		$(this).click(function(){
			kekkaArr.splice(index,1);
			$(this).parent().parent().remove();
			submitKekka();
		})
	})
	
	$('div#kekkaOkiba table').tablesorter();


}

function outputBBS(){
	$('div#opD').remove();
	
	
	var exTxt = "";
	$('div#kekkaOkiba table tbody tr').each(function(){
		var pName = $(this).children('td:eq(1)').html();
		if (!pName) {pName="名無し"};
		exTxt += pName+" さん<br />"
		exTxt += "出兵元:　"+$(this).children('td:eq(2)').html()+"　出兵先:　"+$(this).children('td:eq(3)').html()+"　距離:　"+$(this).children('td:eq(4)').html()+"<br />";
		exTxt += "出発時刻:　"+$(this).children('td:eq(0)').html()+"<br />";
		exTxt += "移動時間:　"+$(this).children('td:eq(8)').html()+"<br />";
		exTxt += "到着時刻:　"+$(this).children('td:eq(7)').html()+"<br />";
		exTxt += "メモ:　"+$(this).children('td:eq(9)').html()+"<br />";
		exTxt += "<br />－－－－－－－－－－－－－－－－－－－－－－＝三[∵]<br /><br />";
	})
	$('<div id="opD"><p>閉じる</p>'+exTxt+'</div>').appendTo('body');
	var left = Math.floor(($(window).width() - $("#opD").outerWidth()) / 2);
	var top  = Math.floor(($(window).height() - $("#opD").outerHeight()) / 2)+$('html, body').scrollTop();
	$("#opD").css({"top": top,"left": left});
	
	$("#opD p").hover(function(){
		$(this).css("cursor","pointer"); 
	},function(){
		$(this).css("cursor","default");
	}).click(function(){
		$('div#opD').remove();
	});

	
}

function resetAll(){
	$('#dist').html('座標が入力されたら距離が表示されるよ。');
	$('#moveTime').html('移動にかかる時間が表示されてもいいはずさ。');
	$('span.kekka').remove();
}

